﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HeuristicLab.Services.Authentication.DataTransfer;

namespace HeuristicLab.Services.Authentication.TestClient
{
    public partial class UserManagement : Form
    {

        AuthenticationService service;

        public UserManagement()
        {
            InitializeComponent();
            Initialize();
        }
        private void Initialize()
        {
            service = new AuthenticationService();
            if (service != null)
            {
                this.bsRoles.DataSource = service.GetRoles();
                this.bsUsers.DataSource = service.GetUsers();

            }
        }

        private void btnUserNew_Click(object sender, EventArgs e)
        {
            UserDetail frmUserDetail = new UserDetail(UserDetailMode.Insert, service);
            frmUserDetail.Show(this);
        }


        private void btnUserModify_Click(object sender, EventArgs e)
        {

           
            if (dgvUsers.SelectedRows.Count == 1)
            {
                User user = (User)dgvUsers.SelectedRows[0].DataBoundItem; 
                if (user != null)
                {
                   
                    UserDetail frmUserDetail = new UserDetail(UserDetailMode.Update,service);
                    frmUserDetail.Show(this);
                    frmUserDetail.Initialize(user);
                }
            }
        }

        private void btnUserDelete_Click(object sender, EventArgs e)
        {
            if (dgvUsers.SelectedRows.Count == 1)
            {
                User user = (User)dgvUsers.SelectedRows[0].DataBoundItem;
                if (user != null)
                {
                    service.DeleteUser(user.UserId);
                }
            }
        }

        private void btnRoleNew_Click(object sender, EventArgs e)
        {
            RoleDetail frmRoleDetail = new RoleDetail(RoleDetailMode.Insert, service,null);
            frmRoleDetail.Show(this);
        }          

        private void btnRoleModify_Click(object sender, EventArgs e)
        {
            if (dgvRoles.SelectedRows.Count == 1)
            {
                Role role = (Role)dgvRoles.SelectedRows[0].DataBoundItem;
                if (role != null)
                {

                    RoleDetail frmRoleDetail = new RoleDetail(RoleDetailMode.Update, service, role);
                    frmRoleDetail.Show(this);
                  
                }
            }
        }

        private void btnRoleDelete_Click(object sender, EventArgs e)
        {
            if (dgvRoles.SelectedRows.Count == 1)
            {
                Role role = (Role)dgvRoles.SelectedRows[0].DataBoundItem;
                if (role != null)
                {
                    service.DeleteRole(role.RoleId);
                }
            }
        }

 

    }
}
